# -*- coding: utf-8 -*-
"""Predict_CSP.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1XCIWx89oxGnbYGbOUbn3nYYa7ZGNeRzr
"""

import joblib
import mne
from MIfunctions import *
import time

def timeit(fn):
    
    def wrap(self, X):
        t0 = time.time()    
        r = fn(self, X)
        t1 = time.time()
        print(f'Timeit:{t1-t0}s')
        return r 
        
    return wrap
    


class Predict_CSP:
    
  def __init__(self,path_model):
    self.path_model = path_model
    self.model = joblib.load(self.path_model)
    
  @timeit
  def predict(self,X):
    for i in range(len(self.model)):
        y = self.model[i].best_estimator_.predict(X)
    return y - 2
    

    
